"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useTenantsDAO = void 0;
const react_1 = require("react");
const ApplifyController_1 = require("../../controllers/ApplifyController");
const useDataStoreList_1 = require("../../hooks/useDataStoreList");
const reg_1 = __importDefault(require("../reg"));
exports.default = useTenantsDAO;
function useTenantsDAO() {
    const { _, isLoading } = (0, useDataStoreList_1.useDataStoreList)(reg_1.default.Tenant);
    const tenantId = (0, ApplifyController_1.useApplifyTenantId)();
    const itemCache = (0, react_1.useRef)([]);
    const [cacheChanged, setCacheChanged] = (0, react_1.useState)(new Date());
    (0, react_1.useEffect)(() => {
        if ((_ === null || _ === void 0 ? void 0 : _.length) !== (itemCache === null || itemCache === void 0 ? void 0 : itemCache.current.length) ||
            _.some(item => {
                const cachedItem = itemCache.current.find(i => i.id === item.id);
                if (!cachedItem)
                    return true;
                const cv = cachedItem['_version'];
                const iv = item['_version'];
                if (cv === undefined && iv === 1)
                    return false;
                return iv > cv;
            })) {
            itemCache.current = _;
            setCacheChanged(new Date());
        }
    }, [_]);
    return {
        tenants: itemCache.current,
        tenantsReady: !isLoading,
    };
}
exports.useTenantsDAO = useTenantsDAO;
//# sourceMappingURL=useTenantsDAO.js.map