import TenantUser from '@thatamplify/core/app/TenantUser/TenantUser';
import TenantUserPS from '@thatamplify/core/app/_propsets/TenantUserPS';
import RecordType from '@thatamplify/core/constants/RecordType';
export default useTenantUsersDAO;
export type TenantUserPatch = {
    name: string;
    p: Partial<TenantUserPS<RecordType.FLAT>>;
};
export interface TenantUsersDAO {
    tenantUsers: TenantUser[];
    updateTenantUser: (id: string, patch: TenantUserPatch) => void;
    updateTenantUserPS: (id: string, patch: Partial<TenantUserPS<RecordType.FLAT>>) => void;
    deleteTenantUser: (itemOrItems: TenantUser | TenantUser[]) => void;
    tenantUsersReady: boolean;
}
export declare function useTenantUsersDAO(): TenantUsersDAO;
