"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.apiSelfSwitchTenant = void 0;
const SelfSwitchTenant_1 = __importDefault(require("@thatamplify/core/app/svcs/SelfSwitchTenant/gql/SelfSwitchTenant"));
const pick_1 = __importDefault(require("lodash/pick"));
const asPM_1 = __importDefault(require("../../utils/asPM"));
const gqlMutation_1 = __importDefault(require("../../utils/gqlMutation"));
const reg_1 = __importDefault(require("../reg"));
exports.default = apiSelfSwitchTenant;
function apiSelfSwitchTenant(values) {
    return __awaiter(this, void 0, void 0, function* () {
        const input = (0, pick_1.default)(values, ['tenantId']);
        return yield (0, asPM_1.default)(reg_1.default.Tenant, (0, gqlMutation_1.default)(SelfSwitchTenant_1.default, input));
    });
}
exports.apiSelfSwitchTenant = apiSelfSwitchTenant;
//# sourceMappingURL=apiSelfSwitchTenant.js.map