import mutation from '@thatamplify/core/app/svcs/SelfSwitchTenant/gql/SelfSwitchTenant'
import InputType from '@thatamplify/core/app/svcs/SelfSwitchTenant/types/SelfSwitchTenantInput'
import Tenant from '@thatamplify/core/app/Tenant/Tenant'
import pick from 'lodash/pick'
import asPM from '../../utils/asPM'
import gqlMutation from '../../utils/gqlMutation'
import reg from '../reg'

export default apiSelfSwitchTenant

export async function apiSelfSwitchTenant(values: InputType): Promise<Tenant> {
	const input = pick(values, ['tenantId'])
	return await asPM(reg.Tenant, gqlMutation(mutation, input))
}
