import mutation from '@thatamplify/core/app/svcs/TenantRegister/gql/TenantRegister'
import InputType from '@thatamplify/core/app/svcs/TenantRegister/types/TenantRegisterInput'
import Tenant from '@thatamplify/core/app/Tenant/Tenant'
import pick from 'lodash/pick'
import asPM from '../../utils/asPM'
import gqlMutation from '../../utils/gqlMutation'
import reg from '../reg'

export default apiTenantRegister

export async function apiTenantRegister(values: InputType): Promise<Tenant> {
	const input = pick(values, ['name'])
	return await asPM(reg.Tenant, gqlMutation(mutation, input))
}
