import mutation from '@thatamplify/core/app/svcs/TenantUserInviteSend/gql/TenantUserInviteSend'
import InputType from '@thatamplify/core/app/svcs/TenantUserInviteSend/types/TenantUserInviteSendInput'
import TenantUserInvite from '@thatamplify/core/app/TenantUserInvite/TenantUserInvite'
import pick from 'lodash/pick'
import asPM from '../../utils/asPM'
import gqlMutation from '../../utils/gqlMutation'
import reg from '../reg'

export default apiTenantUserInviteSend

export async function apiTenantUserInviteSend(values: InputType): Promise<TenantUserInvite> {
	const input = pick(values, ['tenantId', 'email', 'name', 'role'])
	return await asPM(reg.TenantUserInvite, gqlMutation(mutation, input))
}
