import query from '@thatamplify/core/app/svcs/SelfListInvites/gql/SelfListInvites'
import TenantUserInvite from '@thatamplify/core/app/TenantUserInvite/TenantUserInvite'
import { useMemo } from 'react'
import useGQLQuery, { GQLResult } from '../../hooks/useGQLQuery'
import asPMArray from '../../utils/asPMArray'
import gqlQuery from '../../utils/gqlQuery'
import reg from '../reg'

export default useSelfListInvites

export function useSelfListInvites(): GQLResult<TenantUserInvite[]> {
	// NOTE: We memoize the API getter so that the hook doesnt keep refiring

	const api = useMemo(
		() => () => asPMArray(reg.TenantUserInvite, gqlQuery<TenantUserInvite[]>(query)),
		[]
	)
	return useGQLQuery(api)
}
