import query from '@thatamplify/core/app/svcs/SelfListTenants/gql/SelfListTenants'
import { useMemo } from 'react'
import useGQLQuery, { GQLResult } from '../../hooks/useGQLQuery'
import asAWSJSONArray from '../../utils/asAWSJSONArray'
import gqlQuery from '../../utils/gqlQuery'

export default useSelfListTenants

export function useSelfListTenants(): GQLResult<any[]> {
	// NOTE: We memoize the API getter so that the hook doesnt keep refiring

	const api = useMemo(() => () => asAWSJSONArray(gqlQuery<any[]>(query)), [])
	return useGQLQuery(api)
}
