import RolesManager from '@thatamplify/core/auth/classes/RolesManager';
import ApplifyEnv from '@thatamplify/core/env/ApplifyEnv';
import CtrlState from '@thatreact/ctrl/types/CtrlState';
import { SignUpOutput } from 'aws-amplify/auth';
import { DateTime } from 'luxon';
import React, { MutableRefObject } from 'react';
export interface ApplifyControllerProps {
    children: any;
    env: ApplifyEnv;
}
export declare function ApplifyController(props: ApplifyControllerProps): React.JSX.Element;
export default ApplifyController;
export interface ApplifyData {
    _busy: boolean;
    _session: any;
    _roles: RolesManager;
    _subscriptions: any[];
    initialized: boolean;
    authenticated: boolean;
    waitForSynced: boolean;
    user: {
        userId: string;
        username: string;
        attributes: any;
    };
    signupCode: string;
    tenantId: string;
    initStamp: DateTime;
    env: ApplifyEnv;
}
export type ApplifyState = CtrlState<ApplifyData>;
export declare const ApplifyContext: React.Context<ApplifyData>;
export interface ApplifyActions {
    _userDetailsSet: () => void;
    _userDetailsCatch: () => void;
    _userDetailsFinally: () => void;
    _userDetailsLoad: () => void;
    isUserNotConfirmedError: (err: Error) => boolean;
    doClearDb: () => Promise<void>;
    doUserDetailsRefresh: () => Promise<void>;
    doSwitchTenant: (tenantId: string) => Promise<void>;
    doSignInFacebook: () => void;
    doSignInGoogle: () => void;
    doSignUpFacebook: () => void;
    doSignUpGoogle: () => void;
    doSetSignupCode: (v: string) => void;
    doSignIn: (email: string, password: string) => Promise<void>;
    doSignUp: (email: string, password: string) => Promise<SignUpOutput>;
    doResendVerificationCode: (email: string) => any;
    doForgotPassword: (email: string) => Promise<void>;
    doForgotPasswordSubmit: (email: string, code: string, pword: string) => Promise<void>;
    doConfirmSignUp: (email: string, code: string) => Promise<void>;
    doConfirmSignIn: (email: string, code: string) => Promise<void>;
    doSignOut: () => Promise<void>;
    doDataStoreSubscribe: (subscription: any) => any;
    doDataStoreUnsubscribe: (subscription: any) => void;
}
export type ApplifyActionsState = MutableRefObject<ApplifyActions>;
export declare const ApplifyActionsContext: React.Context<ApplifyActions>;
export declare const useApplifyActions: () => ApplifyActions;
export declare function useApplifyTenantId(): string;
export declare function useApplifyUserName(): any;
export declare function useApplifyUserRoles(): RolesManager;
export declare function useApplifyCtxChanged(): any;
export declare function useApplifyTenantTitle(): any;
export declare function useApplifyEnv(): ApplifyEnv<import("@thatamplify/core/env/ApplifyEnv").ApplifyEnvAWS, import("@thatamplify/core/env/ApplifyEnv").ApplifyEnvAuth, import("@thatamplify/core/env/ApplifyEnv").ApplifyEnvURI>;
export declare function useApplifySignupCode(): string;
export declare function useApplifyWaitForSynced(): boolean;
export declare function useApplifyAuthenticated(): boolean;
export declare function useApplifyInitialized(): boolean;
