"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useApplifyInitialized = exports.useApplifyAuthenticated = exports.useApplifyWaitForSynced = exports.useApplifySignupCode = exports.useApplifyEnv = exports.useApplifyTenantTitle = exports.useApplifyCtxChanged = exports.useApplifyUserRoles = exports.useApplifyUserName = exports.useApplifyTenantId = exports.useApplifyActions = exports.ApplifyActionsContext = exports.ApplifyContext = exports.ApplifyController = void 0;
const RolesManager_1 = __importDefault(require("@thatamplify/core/auth/classes/RolesManager"));
const useCtrlActionsCtx_1 = __importDefault(require("@thatreact/ctrl/hooks/useCtrlActionsCtx"));
const useCtrlCtx_1 = __importDefault(require("@thatreact/ctrl/hooks/useCtrlCtx"));
const useCtrlState_1 = __importDefault(require("@thatreact/ctrl/hooks/useCtrlState"));
const useCtrlStateSetter_1 = __importDefault(require("@thatreact/ctrl/hooks/useCtrlStateSetter"));
const luxon_1 = require("luxon");
const react_1 = __importStar(require("react"));
const useApplifyDoClearDb_1 = __importDefault(require("./actions/useApplifyDoClearDb"));
const useApplifyDoConfirmSignIn_1 = __importDefault(require("./actions/useApplifyDoConfirmSignIn"));
const useApplifyDoConfirmSignUp_1 = __importDefault(require("./actions/useApplifyDoConfirmSignUp"));
const useApplifyDoDataStoreSubscribe_1 = __importDefault(require("./actions/useApplifyDoDataStoreSubscribe"));
const useApplifyDoDataStoreUnsubscribe_1 = __importDefault(require("./actions/useApplifyDoDataStoreUnsubscribe"));
const useApplifyDoForgotPassword_1 = __importDefault(require("./actions/useApplifyDoForgotPassword"));
const useApplifyDoForgotPasswordSubmit_1 = __importDefault(require("./actions/useApplifyDoForgotPasswordSubmit"));
const useApplifyDoResendVerificationCode_1 = __importDefault(require("./actions/useApplifyDoResendVerificationCode"));
const useApplifyDoSignIn_1 = __importDefault(require("./actions/useApplifyDoSignIn"));
const useApplifyDoSignInFacebook_1 = __importDefault(require("./actions/useApplifyDoSignInFacebook"));
const useApplifyDoSignInGoogle_1 = __importDefault(require("./actions/useApplifyDoSignInGoogle"));
const useApplifyDoSignOut_1 = __importDefault(require("./actions/useApplifyDoSignOut"));
const useApplifyDoSignUp_1 = __importDefault(require("./actions/useApplifyDoSignUp"));
const useApplifyDoSignUpFacebook_1 = __importDefault(require("./actions/useApplifyDoSignUpFacebook"));
const useApplifyDoSignUpGoogle_1 = __importDefault(require("./actions/useApplifyDoSignUpGoogle"));
const useApplifyDoSwitchTenant_1 = __importDefault(require("./actions/useApplifyDoSwitchTenant"));
const useApplifyDoUserDetailsRefresh_1 = __importDefault(require("./actions/useApplifyDoUserDetailsRefresh"));
const useApplifyEffects_1 = __importDefault(require("./actions/useApplifyEffects"));
const useApplifyIsUserNotConfirmedError_1 = __importDefault(require("./actions/useApplifyIsUserNotConfirmedError"));
const useApplifyUserDetailsCatch_1 = __importDefault(require("./actions/useApplifyUserDetailsCatch"));
const useApplifyUserDetailsFinally_1 = __importDefault(require("./actions/useApplifyUserDetailsFinally"));
const useApplifyUserDetailsLoad_1 = __importDefault(require("./actions/useApplifyUserDetailsLoad"));
const useApplifyUserDetailsSet_1 = __importDefault(require("./actions/useApplifyUserDetailsSet"));
function ApplifyController(props) {
    const { children, env } = props;
    const _s = (0, useCtrlState_1.default)({
        _busy: false,
        _session: undefined,
        _roles: undefined,
        _subscriptions: [],
        initialized: false,
        authenticated: false,
        waitForSynced: true,
        user: undefined,
        signupCode: undefined,
        tenantId: undefined,
        initStamp: luxon_1.DateTime.now(),
        env,
    });
    const _a = (0, react_1.useRef)({});
    _a.current.doSetSignupCode = (0, useCtrlStateSetter_1.default)(_s, 'signupCode');
    _a.current._userDetailsLoad = (0, useApplifyUserDetailsLoad_1.default)(_s, _a);
    _a.current._userDetailsSet = (0, useApplifyUserDetailsSet_1.default)(_s, _a);
    _a.current._userDetailsCatch = (0, useApplifyUserDetailsCatch_1.default)(_s, _a);
    _a.current._userDetailsFinally = (0, useApplifyUserDetailsFinally_1.default)(_s, _a);
    _a.current.isUserNotConfirmedError = (0, useApplifyIsUserNotConfirmedError_1.default)(_s, _a);
    _a.current.doClearDb = (0, useApplifyDoClearDb_1.default)(_s, _a);
    _a.current.doSignInGoogle = (0, useApplifyDoSignInGoogle_1.default)(_s, _a);
    _a.current.doSignInFacebook = (0, useApplifyDoSignInFacebook_1.default)(_s, _a);
    _a.current.doSignUpGoogle = (0, useApplifyDoSignUpGoogle_1.default)(_s, _a);
    _a.current.doSignUpFacebook = (0, useApplifyDoSignUpFacebook_1.default)(_s, _a);
    _a.current.doSignIn = (0, useApplifyDoSignIn_1.default)(_s, _a);
    _a.current.doSignOut = (0, useApplifyDoSignOut_1.default)(_s, _a);
    _a.current.doSignUp = (0, useApplifyDoSignUp_1.default)(_s, _a);
    _a.current.doConfirmSignUp = (0, useApplifyDoConfirmSignUp_1.default)(_s, _a);
    _a.current.doConfirmSignIn = (0, useApplifyDoConfirmSignIn_1.default)(_s, _a);
    _a.current.doForgotPassword = (0, useApplifyDoForgotPassword_1.default)(_s, _a);
    _a.current.doForgotPasswordSubmit = (0, useApplifyDoForgotPasswordSubmit_1.default)(_s, _a);
    _a.current.doResendVerificationCode = (0, useApplifyDoResendVerificationCode_1.default)(_s, _a);
    _a.current.doUserDetailsRefresh = (0, useApplifyDoUserDetailsRefresh_1.default)(_s, _a);
    _a.current.doSwitchTenant = (0, useApplifyDoSwitchTenant_1.default)(_s, _a);
    _a.current.doDataStoreSubscribe = (0, useApplifyDoDataStoreSubscribe_1.default)(_s, _a);
    _a.current.doDataStoreUnsubscribe = (0, useApplifyDoDataStoreUnsubscribe_1.default)(_s, _a);
    (0, useApplifyEffects_1.default)(_s, _a);
    const ctx = (0, useCtrlCtx_1.default)(_s);
    const actionsCtx = (0, useCtrlActionsCtx_1.default)(_a, 'Applify');
    return (react_1.default.createElement(exports.ApplifyContext.Provider, { value: ctx },
        react_1.default.createElement(exports.ApplifyActionsContext.Provider, { value: actionsCtx }, children)));
}
exports.ApplifyController = ApplifyController;
exports.default = ApplifyController;
exports.ApplifyContext = react_1.default.createContext(null);
exports.ApplifyActionsContext = react_1.default.createContext(null);
const useApplifyActions = () => (0, react_1.useContext)(exports.ApplifyActionsContext);
exports.useApplifyActions = useApplifyActions;
function useApplifyTenantId() {
    const { tenantId } = (0, react_1.useContext)(exports.ApplifyContext);
    return (0, react_1.useMemo)(() => {
        if (tenantId === 'triggerignore_tenantA')
            return 'myCo';
        if (tenantId === 'tenantB')
            return 'myOtherCo';
        return tenantId;
    }, [tenantId]);
}
exports.useApplifyTenantId = useApplifyTenantId;
function useApplifyUserName() {
    const { user } = (0, react_1.useContext)(exports.ApplifyContext);
    return (0, react_1.useMemo)(() => (user ? user['attributes']['name'] : ''), [user]);
}
exports.useApplifyUserName = useApplifyUserName;
function useApplifyUserRoles() {
    const { user } = (0, react_1.useContext)(exports.ApplifyContext);
    return (0, react_1.useMemo)(() => RolesManager_1.default.fromCommaList(user ? user['attributes']['custom:roles'] : ''), [user]);
}
exports.useApplifyUserRoles = useApplifyUserRoles;
function useApplifyCtxChanged() {
    const { user, tenantId, initStamp } = (0, react_1.useContext)(exports.ApplifyContext);
    return (0, react_1.useMemo)(() => luxon_1.DateTime.now(), [user, tenantId, initStamp]);
}
exports.useApplifyCtxChanged = useApplifyCtxChanged;
function useApplifyTenantTitle() {
    const { user } = (0, react_1.useContext)(exports.ApplifyContext);
    return (0, react_1.useMemo)(() => (user ? user['attributes']['custom:tenanttitle'] : ''), [user]);
}
exports.useApplifyTenantTitle = useApplifyTenantTitle;
function useApplifyEnv() {
    const { env } = (0, react_1.useContext)(exports.ApplifyContext);
    return (0, react_1.useMemo)(() => env, [env]);
}
exports.useApplifyEnv = useApplifyEnv;
function useApplifySignupCode() {
    const { signupCode } = (0, react_1.useContext)(exports.ApplifyContext);
    return (0, react_1.useMemo)(() => signupCode, [signupCode]);
}
exports.useApplifySignupCode = useApplifySignupCode;
function useApplifyWaitForSynced() {
    const { waitForSynced } = (0, react_1.useContext)(exports.ApplifyContext);
    return (0, react_1.useMemo)(() => waitForSynced, [waitForSynced]);
}
exports.useApplifyWaitForSynced = useApplifyWaitForSynced;
function useApplifyAuthenticated() {
    const { authenticated } = (0, react_1.useContext)(exports.ApplifyContext);
    return (0, react_1.useMemo)(() => authenticated, [authenticated]);
}
exports.useApplifyAuthenticated = useApplifyAuthenticated;
function useApplifyInitialized() {
    const { initialized } = (0, react_1.useContext)(exports.ApplifyContext);
    return (0, react_1.useMemo)(() => initialized, [initialized]);
}
exports.useApplifyInitialized = useApplifyInitialized;
//# sourceMappingURL=ApplifyController.js.map