"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useApplifyDoClearDb = void 0;
const Logger_1 = __importDefault(require("@thats/utils/log/Logger"));
const doCatch_1 = __importDefault(require("@thats/utils/misc/doCatch"));
const datastore_1 = require("aws-amplify/datastore");
const luxon_1 = require("luxon");
const react_1 = require("react");
exports.default = useApplifyDoClearDb;
function useApplifyDoClearDb({ current: _s }, { current: _a }) {
    return (0, react_1.useCallback)(() => __awaiter(this, void 0, void 0, function* () {
        if (!_s.authenticated || !_s.tenantId)
            return;
        Logger_1.default.info('DataStore db cleared');
        yield datastore_1.DataStore.clear().catch(doCatch_1.default);
        yield datastore_1.DataStore.start().catch(doCatch_1.default);
        _s.initStamp = luxon_1.DateTime.now();
        _s.setChanged();
    }), [_s]);
}
exports.useApplifyDoClearDb = useApplifyDoClearDb;
//# sourceMappingURL=useApplifyDoClearDb.js.map