import Logger from '@thats/utils/log/Logger'
import doCatch from '@thats/utils/misc/doCatch'
import { DataStore } from 'aws-amplify/datastore'
import { DateTime } from 'luxon'
import { useCallback } from 'react'
import { ApplifyActionsState, ApplifyState } from '../ApplifyController'

export default useApplifyDoClearDb

export function useApplifyDoClearDb(
	{ current: _s }: ApplifyState,
	{ current: _a }: ApplifyActionsState
) {
	return useCallback(async () => {
		if (!_s.authenticated || !_s.tenantId) return
		Logger.info('DataStore db cleared')
		await DataStore.clear().catch(doCatch)
		await DataStore.start().catch(doCatch)
		_s.initStamp = DateTime.now()
		_s.setChanged()
	}, [_s])
}
