import { confirmResetPassword } from 'aws-amplify/auth'
import { useCallback } from 'react'
import { ApplifyActionsState, ApplifyState } from '../ApplifyController'

export default useApplifyDoForgotPasswordSubmit

export function useApplifyDoForgotPasswordSubmit(
	{ current: _s }: ApplifyState,
	{ current: _a }: ApplifyActionsState
) {
	return useCallback(async (username: string, confirmationCode: string, newPassword: string) => {
		await confirmResetPassword({ username, confirmationCode, newPassword })
	}, [])
}
