import { confirmSignIn, signIn } from 'aws-amplify/auth'
import { useCallback } from 'react'
import { ApplifyActionsState, ApplifyState } from '../ApplifyController'

export default useApplifyDoSignIn

export function useApplifyDoSignIn(
	{ current: _s }: ApplifyState,
	{ current: _a }: ApplifyActionsState
) {
	return useCallback(async (username: string, password: string) => {
		const res = await signIn({ username, password })
		// HACK - if asked for a new password just reset it to the current/previous password
		if (res.nextStep.signInStep === 'CONFIRM_SIGN_IN_WITH_NEW_PASSWORD_REQUIRED') {
			await confirmSignIn({ challengeResponse: password })
		}
	}, [])
}
