import { signOut } from 'aws-amplify/auth'
import { useCallback } from 'react'
import { ApplifyActionsState, ApplifyState } from '../ApplifyController'

export default useApplifyDoSignOut

export function useApplifyDoSignOut(
	{ current: _s }: ApplifyState,
	{ current: _a }: ApplifyActionsState
) {
	return useCallback(async () => {
		// Unsubscribe all subscriptions
		for (const s of _s._subscriptions) {
			try {
				s.unsubscribe()
			} catch {}
		}
		_s._subscriptions = []

		// Clear the database
		await _a.doClearDb()

		// Sign the user out
		await signOut()

		// Done
		_s.setChanged()
	}, [_s, _a])
}
