import { signUp } from 'aws-amplify/auth'
import { useCallback } from 'react'
import { ApplifyActionsState, ApplifyState } from '../ApplifyController'

export default useApplifyDoSignUp

export function useApplifyDoSignUp(
	{ current: _s }: ApplifyState,
	{ current: _a }: ApplifyActionsState
) {
	return useCallback(async (email: string, password: string) => {
		return await signUp({
			username: email,
			password,
			options: {
				userAttributes: { email },
			},
		})
	}, [])
}
