"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useApplifyDoUserDetailsRefresh = void 0;
const auth_1 = require("aws-amplify/auth");
const react_1 = require("react");
exports.default = useApplifyDoUserDetailsRefresh;
function useApplifyDoUserDetailsRefresh({ current: _s }, { current: _a }) {
    return (0, react_1.useCallback)(() => __awaiter(this, void 0, void 0, function* () {
        if (!_s.user)
            throw new Error('Not authenticated');
        if (_s._busy)
            return;
        _s._busy = true;
        yield (0, auth_1.getCurrentUser)()
            .then(v => {
            _s.user.userId = v.userId;
            _s.user.username = v.username;
            _s.authenticated = true;
            return (0, auth_1.fetchUserAttributes)();
        })
            .then(v => {
            _s.user.attributes = v;
            return (0, auth_1.fetchAuthSession)({ forceRefresh: true });
        })
            .then(v => {
            _s._session = v;
            _a._userDetailsSet();
        })
            .catch(_a._userDetailsCatch)
            .finally(_a._userDetailsFinally);
    }), [_s, _a]);
}
exports.useApplifyDoUserDetailsRefresh = useApplifyDoUserDetailsRefresh;
//# sourceMappingURL=useApplifyDoUserDetailsRefresh.js.map