import { fetchAuthSession, fetchUserAttributes, getCurrentUser } from 'aws-amplify/auth'
import { useCallback } from 'react'
import { ApplifyActionsState, ApplifyState } from '../ApplifyController'

export default useApplifyDoUserDetailsRefresh

export function useApplifyDoUserDetailsRefresh(
	{ current: _s }: ApplifyState,
	{ current: _a }: ApplifyActionsState
) {
	return useCallback(async () => {
		if (!_s.user) throw new Error('Not authenticated')
		if (_s._busy) return
		_s._busy = true
		await getCurrentUser()
			.then(v => {
				_s.user.userId = v.userId
				_s.user.username = v.username
				_s.authenticated = true
				return fetchUserAttributes()
			})
			.then(v => {
				_s.user.attributes = v
				return fetchAuthSession({ forceRefresh: true })
			})
			.then(v => {
				_s._session = v
				_a._userDetailsSet()
			})
			.catch(_a._userDetailsCatch)
			.finally(_a._userDetailsFinally)
	}, [_s, _a])
}
