"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useApplifyEffects = void 0;
const Logger_1 = __importDefault(require("@thats/utils/log/Logger"));
const datastore_1 = require("aws-amplify/datastore");
const utils_1 = require("aws-amplify/utils");
const react_1 = require("react");
exports.default = useApplifyEffects;
function useApplifyEffects({ current: _s }, { current: _a }) {
    const listener = (0, react_1.useCallback)(data => {
        switch (data.payload.event) {
            case 'signedIn':
            case 'signedUp':
            case 'signedOut':
            case 'tokenRefresh':
                return void _a._userDetailsLoad();
            default: {
                Logger_1.default.info('useApplifyEffects: unhandled event', data);
                return undefined;
            }
        }
    }, [_a]);
    (0, react_1.useEffect)(() => {
        datastore_1.DataStore.configure({});
        const listenCancel = utils_1.Hub.listen('auth', listener);
        void _a._userDetailsLoad();
        return () => listenCancel();
    }, [listener, _a]);
}
exports.useApplifyEffects = useApplifyEffects;
//# sourceMappingURL=useApplifyEffects.js.map