"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useApplifyUserDetailsLoad = void 0;
const auth_1 = require("aws-amplify/auth");
const react_1 = require("react");
exports.default = useApplifyUserDetailsLoad;
function useApplifyUserDetailsLoad({ current: _s }, { current: _a }) {
    return (0, react_1.useCallback)(() => {
        if (_s._busy)
            return;
        _s._busy = true;
        _s.user = {};
        void (0, auth_1.getCurrentUser)()
            .then(v => {
            _s.user.userId = v.userId;
            _s.user.username = v.username;
            _s.authenticated = true;
            return (0, auth_1.fetchUserAttributes)();
        })
            .then(v => {
            _s.user.attributes = v;
            return (0, auth_1.fetchAuthSession)();
        })
            .then(v => {
            _s._session = v;
            _a._userDetailsSet();
        })
            .catch(_a._userDetailsCatch)
            .finally(_a._userDetailsFinally);
    }, [_s, _a]);
}
exports.useApplifyUserDetailsLoad = useApplifyUserDetailsLoad;
//# sourceMappingURL=useApplifyUserDetailsLoad.js.map