import { fetchAuthSession, fetchUserAttributes, getCurrentUser } from 'aws-amplify/auth'
import { useCallback } from 'react'
import { ApplifyActionsState, ApplifyState } from '../ApplifyController'

export default useApplifyUserDetailsLoad

export function useApplifyUserDetailsLoad(
	{ current: _s }: ApplifyState,
	{ current: _a }: ApplifyActionsState
) {
	return useCallback(() => {
		if (_s._busy) return
		_s._busy = true
		_s.user = {} as any
		void getCurrentUser()
			.then(v => {
				_s.user.userId = v.userId
				_s.user.username = v.username
				_s.authenticated = true
				return fetchUserAttributes()
			})
			.then(v => {
				_s.user.attributes = v
				return fetchAuthSession()
			})
			.then(v => {
				_s._session = v
				_a._userDetailsSet()
			})
			.catch(_a._userDetailsCatch)
			.finally(_a._userDetailsFinally)
	}, [_s, _a])
}
