import processCognitoGroups from '@thatamplify/core/auth/utils/processCognitoGroups'
import { useCallback } from 'react'
import { ApplifyActionsState, ApplifyState } from '../ApplifyController'

export default useApplifyUserDetailsSet

export function useApplifyUserDetailsSet(
	{ current: _s }: ApplifyState,
	{ current: _a }: ApplifyActionsState
) {
	return useCallback(() => {
		const payload = _s._session?.tokens?.accessToken?.payload
		const result = processCognitoGroups(payload?.['cognito:groups'] ?? [])
		_s.tenantId = result.tenantId
		_s._roles = result.roles
	}, [_s])
}
