"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useDataCache = exports.subscribers = exports.cache = void 0;
const IDMap_1 = __importDefault(require("@thats/utils/map/IDMap"));
const react_1 = require("react");
const uuid = __importStar(require("uuid"));
const ApplifyController_1 = require("../controllers/ApplifyController");
const gqlMutation_1 = __importDefault(require("../utils/gqlMutation"));
const gqlSubscribe_1 = __importDefault(require("../utils/gqlSubscribe"));
const gqlify_1 = __importDefault(require("./gqlify"));
exports.cache = {};
exports.subscribers = [];
function useDataCache(PM, gql) {
    const tenantId = (0, ApplifyController_1.useApplifyTenantId)();
    const [cacheChanged, setCacheChanged] = (0, react_1.useState)(new Date());
    const cacheKey = (0, react_1.useRef)(`${tenantId}:${PM.name}`);
    const subscriptions = (0, react_1.useRef)({});
    const handleChange = (0, react_1.useCallback)(() => setCacheChanged(new Date()), [setCacheChanged]);
    const triggerChange = (0, react_1.useCallback)(() => exports.subscribers.forEach(cb => cb()), []);
    (0, react_1.useEffect)(() => {
        exports.subscribers.push(handleChange);
        return () => {
            const index = exports.subscribers.indexOf(handleChange);
            if (index > -1)
                exports.subscribers.splice(index, 1);
        };
    }, [handleChange]);
    const update = (0, react_1.useCallback)((id, patch) => {
        const item = exports.cache[cacheKey.current].get(id);
        const newItem = PM.copyOf(item, u => {
            var _a, _b;
            return Object.assign(u, Object.assign(Object.assign(Object.assign({}, u), patch), { p: Object.assign(Object.assign({}, ((_a = u['p']) !== null && _a !== void 0 ? _a : {})), ((_b = patch['p']) !== null && _b !== void 0 ? _b : {})) }));
        });
        void (0, gqlMutation_1.default)(gql.update, (0, gqlify_1.default)(newItem));
        exports.cache[cacheKey.current].set(newItem.id, newItem);
        triggerChange();
    }, [PM, gql.update, triggerChange]);
    const create = (0, react_1.useCallback)((init) => {
        const id = uuid.v4();
        const newItem = new PM(Object.assign({ tenantId, id }, init));
        exports.cache[cacheKey.current].set(newItem.id, newItem);
        void (0, gqlMutation_1.default)(gql.create, (0, gqlify_1.default)(newItem));
        triggerChange();
        return newItem;
    }, [PM, gql.create, tenantId, triggerChange]);
    const deleteByIds = (0, react_1.useCallback)((ids) => {
        ids.forEach(id => {
            void (0, gqlMutation_1.default)(gql.delete, { input: { id } });
            exports.cache[cacheKey.current].delete(id);
        });
        triggerChange();
    }, [gql.delete, triggerChange]);
    const set = (0, react_1.useCallback)((item) => {
        if (!item)
            return;
        if (!exports.cache[cacheKey.current])
            exports.cache[cacheKey.current] = new IDMap_1.default();
        exports.cache[cacheKey.current].set(item.id, item);
        triggerChange();
    }, [triggerChange]);
    const setAll = (0, react_1.useCallback)((items) => {
        if (!items)
            return;
        if (!exports.cache[cacheKey.current])
            exports.cache[cacheKey.current] = new IDMap_1.default();
        items.forEach(item => exports.cache[cacheKey.current].set(item.id, item));
        triggerChange();
    }, [triggerChange]);
    const get = (0, react_1.useCallback)((id) => { var _a, _b; return ((_b = (_a = exports.cache[cacheKey.current]) === null || _a === void 0 ? void 0 : _a.get(id)) !== null && _b !== void 0 ? _b : undefined); }, []);
    const getAll = (0, react_1.useCallback)(() => { var _a, _b; return ((_b = (_a = exports.cache[cacheKey.current]) === null || _a === void 0 ? void 0 : _a.valuesArr()) !== null && _b !== void 0 ? _b : []); }, [cacheKey]);
    (0, react_1.useEffect)(() => {
        const s = subscriptions.current;
        const k = `${tenantId}:${PM.name}`;
        s[`${k}:create`] = (0, gqlSubscribe_1.default)(gql.onCreate, { tenantId }, (v) => __awaiter(this, void 0, void 0, function* () {
            const newItem = PM['fromJSON'](v.data[`onCreate${PM.name}`]);
            exports.cache[k].set(newItem.id, newItem);
            triggerChange();
        }));
        s[`${k}:delete`] = (0, gqlSubscribe_1.default)(gql.onDelete, { tenantId }, (v) => __awaiter(this, void 0, void 0, function* () {
            const id = v.data[`onDelete${PM.name}`].id;
            exports.cache[k].delete(id);
            triggerChange();
        }));
        s[`${k}:update`] = (0, gqlSubscribe_1.default)(gql.onUpdate, { tenantId }, (v) => __awaiter(this, void 0, void 0, function* () {
            const updatedItem = PM['fromJSON'](v.data[`onUpdate${PM.name}`]);
            exports.cache[k].set(updatedItem.id, updatedItem);
            triggerChange();
        }));
        return () => {
            Object.keys(s).forEach(key => {
                var _a, _b;
                try {
                    (_b = (_a = s[key]) === null || _a === void 0 ? void 0 : _a['unsubscribe']) === null || _b === void 0 ? void 0 : _b.call(_a);
                    delete s[key];
                }
                catch (_c) { }
            });
        };
    }, [PM, gql, tenantId, triggerChange]);
    (0, react_1.useEffect)(() => {
        cacheKey.current = `${tenantId}:${PM.name}`;
    }, [PM.name, tenantId]);
    return (0, react_1.useMemo)(() => ({
        cacheChanged,
        get,
        getAll,
        set,
        setAll,
        update,
        create,
        deleteByIds,
    }), [cacheChanged, create, deleteByIds, get, getAll, set, setAll, update]);
}
exports.useDataCache = useDataCache;
exports.default = useDataCache;
//# sourceMappingURL=useDataCache.js.map