import IDMap from '@thats/utils/map/IDMap';
import TenantedTINP from '@thats/utils/types/TenantedTINP';
import { ModelInit, PersistentModelConstructor as PMC } from 'aws-amplify/datastore';
export declare const cache: {
    [key: string]: IDMap<any>;
};
export declare const subscribers: (() => void)[];
export type DataPatch = {
    p?: any;
};
export type DataCacheGQL = {
    create: any;
    update: any;
    delete: any;
    onCreate: any;
    onDelete: any;
    onUpdate: any;
};
export declare function useDataCacheByProjectId<T extends TenantedTINP = TenantedTINP, PATCH extends DataPatch = DataPatch>(PM: PMC<T>, gql: DataCacheGQL, projectId: string): {
    cacheChanged: Date;
    get: (id: string) => T;
    getAll: () => T[];
    set: (item: T) => void;
    setAll: (items: T[]) => void;
    update: (id: string, patch: PATCH) => void;
    create: (init: ModelInit<T>) => T;
    deleteByIds: (ids: string[]) => void;
};
export default useDataCacheByProjectId;
