"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useGQLMutation = void 0;
const doNothing_1 = __importDefault(require("@thats/utils/misc/doNothing"));
const react_1 = require("react");
function useGQLMutation(api) {
    const [initiated, setInitiated] = (0, react_1.useState)(false);
    const [data, setData] = (0, react_1.useState)(undefined);
    const [error, setError] = (0, react_1.useState)(undefined);
    const [loading, setLoading] = (0, react_1.useState)(true);
    const refresh = (0, react_1.useCallback)(() => __awaiter(this, void 0, void 0, function* () {
        setLoading(true);
        setError(undefined);
        setData(undefined);
        try {
            setData(yield api());
        }
        catch (e) {
            setError(e);
        }
        setLoading(false);
    }), [api]);
    (0, react_1.useEffect)(() => {
        if (initiated)
            return;
        setInitiated(true);
        refresh().catch(doNothing_1.default);
    }, [initiated, refresh]);
    return { data, error, loading: !initiated, refresh };
}
exports.useGQLMutation = useGQLMutation;
//# sourceMappingURL=useGQLMutation.js.map