import QueryResponse from '@thatamplify/core/api/query/QueryResponse'
import GQLError from '@thatamplify/core/errors/GQLError'

export default asAWSJSON

export async function asAWSJSON(p: Promise<QueryResponse<any>>): Promise<any> {
	const { data, errors } = await p
	if (errors) throw new GQLError(errors)
	return JSON.parse(Object.values(data)[0])
}
