import QueryResponse from '@thatamplify/core/api/query/QueryResponse'
import GQLError from '@thatamplify/core/errors/GQLError'

export default asAWSJSONArray

export async function asAWSJSONArray(p: Promise<QueryResponse<any>>): Promise<any> {
	const { data, errors } = await p
	if (errors) throw new GQLError(errors)
	return Object.values(data)[0].map(JSON.parse)
}
