import QueryResponse from '@thatamplify/core/api/query/QueryResponse'
import GQLError from '@thatamplify/core/errors/GQLError'

export default asBoolean

export async function asBoolean(p: Promise<QueryResponse<boolean>>): Promise<boolean> {
	const { data, errors } = await p
	if (errors) throw new GQLError(errors)
	const rData = Object.values(data)[0]
	return !!rData
}
