import QueryResponse from '@thatamplify/core/api/query/QueryResponse'
import Type from '@thatamplify/core/app/_/Type'
import GQLError from '@thatamplify/core/errors/GQLError'
import { PersistentModel, PersistentModelConstructor } from 'aws-amplify/datastore'

export default asPM

export async function asPM<PM extends PersistentModel, T extends Type>(
	PM: PersistentModelConstructor<PM>,
	p: Promise<QueryResponse<T, T>>
): Promise<PM> {
	const { data, errors } = await p
	if (errors) throw new GQLError(errors)
	const rData = Object.values(data)[0]
	return rData ? PM['fromJSON'](rData) : undefined
}
