"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.asPMArray = void 0;
const GQLError_1 = __importDefault(require("@thatamplify/core/errors/GQLError"));
exports.default = asPMArray;
function asPMArray(PM, p) {
    return __awaiter(this, void 0, void 0, function* () {
        const { data, errors } = yield p;
        if (errors)
            throw new GQLError_1.default(errors);
        let rData = Object.values(data)[0];
        if (rData === null || rData === void 0 ? void 0 : rData['items'])
            rData = rData['items'];
        return rData ? rData.map(r => PM['fromJSON'](r)) : [];
    });
}
exports.asPMArray = asPMArray;
//# sourceMappingURL=asPMArray.js.map