import QueryResponse from '@thatamplify/core/api/query/QueryResponse'
import Connection from '@thatamplify/core/app/_/Connection'
import Type from '@thatamplify/core/app/_/Type'
import GQLError from '@thatamplify/core/errors/GQLError'
import { PersistentModel, PersistentModelConstructor } from 'aws-amplify/datastore'

export default asPMConnection

export async function asPMConnection<PM extends PersistentModel, T extends Type>(
	PM: PersistentModelConstructor<PM>,
	p: Promise<QueryResponse<Connection<T>, T>>
): Promise<Connection<PM>> {
	const { data, errors } = await p
	if (errors) throw new GQLError(errors)
	const rData = Object.values(data)[0]
	rData['items'] = rData['items'].map(r => PM['fromJSON'](r))
	return rData as unknown as Connection<PM>
}
