"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.gqlQuery = void 0;
const Logger_1 = __importDefault(require("@thats/utils/log/Logger"));
const api_1 = require("aws-amplify/api");
function gqlQuery(query, variables, o = {}) {
    return __awaiter(this, void 0, void 0, function* () {
        const client = (0, api_1.generateClient)();
        const { log = false } = o;
        let result;
        if (log)
            Logger_1.default.info('Query Request', { query, variables });
        try {
            result = yield client.graphql({ query, variables });
        }
        catch (e) {
            if (e.errors) {
                result = e;
            }
            else {
                result = { data: undefined, errors: [e] };
            }
        }
        if (log)
            Logger_1.default.info('Query Response', result);
        return result;
    });
}
exports.gqlQuery = gqlQuery;
exports.default = gqlQuery;
//# sourceMappingURL=gqlQuery.js.map