"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.gqlSubscribe = void 0;
const Logger_1 = __importDefault(require("@thats/utils/log/Logger"));
const api_1 = require("aws-amplify/api");
function gqlSubscribe(query, variables, next, error) {
    try {
        const client = (0, api_1.generateClient)();
        return client.graphql({ query, variables }).subscribe({ next, error });
    }
    catch (e) {
        Logger_1.default.error('Problem subscribing', e);
    }
}
exports.gqlSubscribe = gqlSubscribe;
exports.default = gqlSubscribe;
//# sourceMappingURL=gqlSubscribe.js.map