import SubscribeResponse from '@thatamplify/core/api/query/SubscribeResponse'
import Type from '@thatamplify/core/app/_/Type'
import Logger from '@thats/utils/log/Logger'
import { generateClient } from 'aws-amplify/api'

export type GeneratedSubscription = string & {
	__generatedSubscriptionInput: any
	__generatedSubscriptionOutput: any
}
export function gqlSubscribe<T extends Type = any>(
	query: GeneratedSubscription,
	variables?: any,
	next?: (value: { data: { [key: string]: T } }) => void,
	error?: (error: any) => void
): SubscribeResponse {
	try {
		const client = generateClient()
		return client.graphql({ query, variables }).subscribe({ next, error })
	} catch (e) {
		Logger.error('Problem subscribing', e)
	}
}
export default gqlSubscribe
